Package com.smartgwt.client.widgets

# Class Scrollbar

java.lang.Object
com.google.gwt.user.client.ui.UIObject
com.google.gwt.user.client.ui.Widget
com.smartgwt.client.widgets.BaseWidget
com.smartgwt.client.widgets.Canvas
com.smartgwt.client.widgets.StatefulCanvas
com.smartgwt.client.widgets.StretchImg
com.smartgwt.client.widgets.Scrollbar

All Implemented Interfaces:
  `HasAttachHandlers`, `HasHandlers`, `EventListener`, `HasVisibility`, `IsWidget`, `LogicalStructure`, `HasClearHandlers`, `HasClickHandlers`, `HasDoubleClickHandlers`, `HasDragMoveHandlers`, `HasDragRepositionMoveHandlers`, `HasDragRepositionStartHandlers`, `HasDragRepositionStopHandlers`, `HasDragResizeMoveHandlers`, `HasDragResizeStartHandlers`, `HasDragResizeStopHandlers`, `HasDragStartHandlers`, `HasDragStopHandlers`, `HasDropHandlers`, `HasDropMoveHandlers`, `HasDropOutHandlers`, `HasDropOverHandlers`, `HasFocusChangedHandlers`, `HasHoverHandlers`, `HasHoverHiddenHandlers`, `HasKeyDownHandlers`, `HasKeyPressHandlers`, `HasMouseDownHandlers`, `HasMouseMoveHandlers`, `HasMouseOutHandlers`, `HasMouseOverHandlers`, `HasMouseStillDownHandlers`, `HasMouseUpHandlers`, `HasMouseWheelHandlers`, `HasMovedHandlers`, `HasParentMovedHandlers`, `HasResizedHandlers`, `HasRightMouseDownHandlers`, `HasRuleContextChangedHandlers`, `HasScrolledHandlers`, `HasShowContextMenuHandlers`, `HasVisibilityChangedHandlers`

public class Scrollbar extends StretchImg
The Scrollbar widget implements cross-platform, image-based scrollbars that control the scrolling of content in other widgets. Scrollbar widgets are created and displayed automatically for widgets that require them, based on settings for `Canvas.overflow`.

The scrollbar's appearance is based on a `StretchImg` for the "track", which consists of two fixed size buttons and a stretchable center segment, and the ScrollThumb, the draggable portion of the scrollbar, also a StretchImg, with an optional `grip`.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class com.google.gwt.user.client.ui.UIObject

  `UIObject.DebugIdImpl, UIObject.DebugIdImplEnabled`

- ## Field Summary

  ### Fields inherited from class com.smartgwt.client.widgets.BaseWidget

  `config, configOnly, factoryCreated, factoryProperties, id, nativeObject, scClassName`

  ### Fields inherited from class com.google.gwt.user.client.ui.UIObject

  `DEBUG_ID_PREFIX`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Scrollbar()`
  `Scrollbar(JavaScriptObject jsObj)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static void`
  `changeAutoChildDefaults(String autoChildName, Canvas defaults)`
  Changes the defaults for Canvas AutoChildren named `autoChildName`.
  `static void`
  `changeAutoChildDefaults(String autoChildName, FormItem defaults)`
  Changes the defaults for FormItem AutoChildren named `autoChildName`.
  `protected JavaScriptObject`
  `create()`
  `Boolean`
  `getAllowThumbDownState()`
  If true, the thumb's appearance changes when it's clicked on.
  `Boolean`
  `getAllowThumbOverState()`
  If true, the thumb's appearance changes when the user rolls over it.
  `Boolean`
  `getAutoEnable()`
  If true, this scrollbar will automatically enable when the scrollTarget is scrollable (i.e., when the contents of the scrollTarget exceed its clip size in the direction relevant to this scrollbar), and automatically disable when the scrollTarget is not scrollable.
  `Integer`
  `getBtnSize()`
  The size of the square buttons (arrows) at the ends of this scrollbar.
  `StretchItem`
  `getCornerImg()`
  The StretchItem for the corner between vertical and horizontal scrollbars.
  `Integer`
  `getCornerSize()`
  Allows the size of the corner segment to be set independently of the `btnSize`.
  `String`
  `getCornerSrc()`
  URL for the corner image, a singular image that appears in the corner when both h and v scrollbars are showing.
  `StretchItem`
  `getEndImg()`
  The StretchItem for the end of a scrollbar (the "scroll down" or "scroll right" button image).
  `Integer`
  `getEndThumbOverlap()`
  Number of pixels the thumb is allowed to overlap the buttons at the end of the track.
  `String`
  `getHSrc()`
  Base URL for the images used for the horizontal scrollbar track and end buttons.
  `LogicalStructureObject`
  `getLogicalStructure()`
  Getter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
  `static Scrollbar`
  `getOrCreateRef(JavaScriptObject jsObj)`
  `Canvas`
  `getScrollTarget()`
  The widget whose contents should be scrolled by this scrollbar.
  `Boolean`
  `getShowCorner()`
  If true, displays a corner piece at the bottom end of a vertical scrollbar, or the right end of a horizontal scrollbar.
  `Boolean`
  `getShowTrackButtons()`
  Should the track buttons that allow page scrolling be shown?
  `Boolean`
  `getShowTrackEnds()`
  If true, the scrollbar uses a 5-segment rather than 3-segment image representation, where the 3 interior image segments have the same state (Down, Over, etc), independent of the two outermost image segments.
  `String`
  `getSkinImgDir()`
  Where are the skin images for the Scrollbar.
  `StretchItem`
  `getStartImg()`
  The StretchItem for the start of a scrollbar (the "scroll up" or "scroll left" button image).
  `Integer`
  `getStartThumbOverlap()`
  Number of pixels the thumb is allowed to overlap the buttons at the start of the track.
  `Integer`
  `getThumbInset()`
  Inset of the thumb relative to the track.
  `int`
  `getThumbMinSize()`
  The minimum pixel size of the draggable thumb regardless of how large the scrolling region becomes.
  `int`
  `getThumbOverlap()`
  Number of pixels the thumb is allowed to overlap the buttons at each end of the track.
  `int`
  `getTrackEndHeight()`
  The minimum pixel height of the track end segments (if enabled with showTrackEnds).
  `StretchItem`
  `getTrackEndImg()`
  The StretchItem for the end of a scrollbar track.
  `int`
  `getTrackEndWidth()`
  The minimum pixel width of the track end segments (if enabled with showTrackEnds).
  `StretchItem`
  `getTrackImg()`
  The StretchItem for the middle part of a scrollbar track, which usually takes up the majority of the width or height of the scrollbar.
  `StretchItem`
  `getTrackStartImg()`
  The StretchItem for the start of a scrollbar track.
  `String`
  `getVSrc()`
  Base URL for the images used for the vertical scrollbar track and end buttons.
  `static void`
  `preloadImages()`
  Preload primary Scrollbar skin images.
  `Scrollbar`
  `setAllowThumbDownState(Boolean allowThumbDownState)`
  If true, the thumb's appearance changes when it's clicked on.
  `Scrollbar`
  `setAllowThumbOverState(Boolean allowThumbOverState)`
  If true, the thumb's appearance changes when the user rolls over it.
  `Scrollbar`
  `setAutoEnable(Boolean autoEnable)`
  If true, this scrollbar will automatically enable when the scrollTarget is scrollable (i.e., when the contents of the scrollTarget exceed its clip size in the direction relevant to this scrollbar), and automatically disable when the scrollTarget is not scrollable.
  `Scrollbar`
  `setBtnSize(Integer btnSize)`
  The size of the square buttons (arrows) at the ends of this scrollbar.
  `Scrollbar`
  `setCornerImg(StretchItem cornerImg)`
  The StretchItem for the corner between vertical and horizontal scrollbars.
  `Scrollbar`
  `setCornerSize(Integer cornerSize)`
  Allows the size of the corner segment to be set independently of the `btnSize`.
  `Scrollbar`
  `setCornerSrc(String cornerSrc)`
  URL for the corner image, a singular image that appears in the corner when both h and v scrollbars are showing.
  `static void`
  `setDefaultProperties(Scrollbar scrollbarProperties)`
  Class level method to set the default properties of this class.
  `Scrollbar`
  `setEndImg(StretchItem endImg)`
  The StretchItem for the end of a scrollbar (the "scroll down" or "scroll right" button image).
  `Scrollbar`
  `setEndThumbOverlap(Integer endThumbOverlap)`
  Number of pixels the thumb is allowed to overlap the buttons at the end of the track.
  `Scrollbar`
  `setHSrc(String hSrc)`
  Base URL for the images used for the horizontal scrollbar track and end buttons.
  `LogicalStructureObject`
  `setLogicalStructure(ScrollbarLogicalStructure s)`
  Setter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
  `Scrollbar`
  `setScrollTarget(Canvas scrollTarget)`
  The widget whose contents should be scrolled by this scrollbar.
  `Scrollbar`
  `setShowCorner(Boolean showCorner)`
  If true, displays a corner piece at the bottom end of a vertical scrollbar, or the right end of a horizontal scrollbar.
  `Scrollbar`
  `setShowTrackButtons(Boolean showTrackButtons)`
  Should the track buttons that allow page scrolling be shown?
  `Scrollbar`
  `setShowTrackEnds(Boolean showTrackEnds)`
  If true, the scrollbar uses a 5-segment rather than 3-segment image representation, where the 3 interior image segments have the same state (Down, Over, etc), independent of the two outermost image segments.
  `Scrollbar`
  `setSkinImgDir(String skinImgDir)`
  Where are the skin images for the Scrollbar.
  `Scrollbar`
  `setStartImg(StretchItem startImg)`
  The StretchItem for the start of a scrollbar (the "scroll up" or "scroll left" button image).
  `Scrollbar`
  `setStartThumbOverlap(Integer startThumbOverlap)`
  Number of pixels the thumb is allowed to overlap the buttons at the start of the track.
  `Scrollbar`
  `setThumbInset(Integer thumbInset)`
  Inset of the thumb relative to the track.
  `Scrollbar`
  `setThumbMinSize(int thumbMinSize)`
  The minimum pixel size of the draggable thumb regardless of how large the scrolling region becomes.
  `Scrollbar`
  `setThumbOverlap(int thumbOverlap)`
  Number of pixels the thumb is allowed to overlap the buttons at each end of the track.
  `Scrollbar`
  `setTrackEndHeight(int trackEndHeight)`
  The minimum pixel height of the track end segments (if enabled with showTrackEnds).
  `Scrollbar`
  `setTrackEndImg(StretchItem trackEndImg)`
  The StretchItem for the end of a scrollbar track.
  `Scrollbar`
  `setTrackEndWidth(int trackEndWidth)`
  The minimum pixel width of the track end segments (if enabled with showTrackEnds).
  `Scrollbar`
  `setTrackImg(StretchItem trackImg)`
  The StretchItem for the middle part of a scrollbar track, which usually takes up the majority of the width or height of the scrollbar.
  `Scrollbar`
  `setTrackStartImg(StretchItem trackStartImg)`
  The StretchItem for the start of a scrollbar track.
  `Scrollbar`
  `setVSrc(String vSrc)`
  Base URL for the images used for the vertical scrollbar track and end buttons.

  ### Methods inherited from class com.smartgwt.client.widgets.StretchImg

  `getCapSize, getGripImgSuffix, getIgnoreRTL, getImageType, getItemBaseStyle, getItems, getShowDownGrip, getShowGrip, getShowRollOverGrip, getShowTitle, getSrc, getVertical, setCapSize, setDefaultProperties, setGripImgSuffix, setIgnoreRTL, setImageType, setItemBaseStyle, setItems, setLogicalStructure, setShowDownGrip, setShowGrip, setShowRollOverGrip, setShowTitle, setSrc, setState, setState, setVertical`

  ### Methods inherited from class com.smartgwt.client.widgets.StatefulCanvas

  `addToRadioGroup, deselect, getActionType, getAlign, getAriaLabel, getAriaStateDefaults, getAutoFit, getBaseStyle, getEditProxyConstructor, getHeight, getHeightAsString, getIcon, getIconHeight, getIconOrientation, getIconSize, getIconStyle, getIconWidth, getLabelHPad, getLabelVPad, getOverCanvas, getOverCanvasConstructor, getRadioGroup, getRedrawOnStateChange, getSelected, getShowDisabled, getShowDisabledIcon, getShowDown, getShowDownIcon, getShowFocused, getShowFocusedAsOver, getShowFocusedIcon, getShowMenuOnClick, getShowOverCanvas, getShowRollOver, getShowRollOverIcon, getShowRTLIcon, getShowSelectedIcon, getState, getStateSuffix, getStyleName, getTitle, getValign, getVIconStyle, getWidth, getWidthAsString, isSelected, removeFromRadioGroup, removeFromRadioGroup, select, setActionType, setAlign, setAriaLabel, setAutoFit, setBaseStyle, setDefaultProperties, setEditProxyConstructor, setHeight, setHeight, setIcon, setIconHeight, setIconOrientation, setIconSize, setIconStyle, setIconWidth, setLabelHPad, setLabelVPad, setLogicalStructure, setOverCanvasConstructor, setRadioGroup, setRedrawOnStateChange, setSelected, setShowDisabled, setShowDisabledIcon, setShowDown, setShowDownIcon, setShowFocused, setShowFocusedAsOver, setShowFocusedIcon, setShowMenuOnClick, setShowOverCanvas, setShowRollOver, setShowRollOverIcon, setShowRTLIcon, setShowSelectedIcon, setState, setStyleName, setTitle, setTitleFormatter, setTitleStyle, setValign, setVIconStyle, setWidth, setWidth`

  ### Methods inherited from class com.smartgwt.client.widgets.Canvas

  `addChild, addChild, addChild, addChild, addChild, addClearHandler, addClickHandler, addDoubleClickHandler, addDragMoveHandler, addDragRepositionMoveHandler, addDragRepositionStartHandler, addDragRepositionStopHandler, addDragResizeMoveHandler, addDragResizeStartHandler, addDragResizeStopHandler, addDragStartHandler, addDragStopHandler, addDropHandler, addDropMoveHandler, addDropOutHandler, addDropOverHandler, addFocusChangedHandler, addHoverHandler, addHoverHiddenHandler, addKeyDownHandler, addKeyPressHandler, addMouseDownHandler, addMouseMoveHandler, addMouseOutHandler, addMouseOverHandler, addMouseStillDownHandler, addMouseUpHandler, addMouseWheelHandler, addMovedHandler, addParentMovedHandler, addPeer, addPeer, addPeer, addPeer, addResizedHandler, addRightMouseDownHandler, addRuleContextChangedHandler, addScrolledHandler, addShowContextMenuHandler, addSnapAlignCandidate, addStyleName, addVisibilityChangedHandler, adjustForContent, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateHide, animateHide, animateHide, animateHide, animateHide, animateHide, animateHide, animateMove, animateMove, animateMove, animateMove, animateRect, animateRect, animateRect, animateRect, animateResize, animateResize, animateResize, animateResize, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateShow, animateShow, animateShow, animateShow, animateShow, animateShow, animateShow, asSGWTComponent, blur, bringToFront, clear, clearExplicitTabIndex, clickMaskUp, clickMaskUp, contains, contains, containsEvent, containsEventTarget, containsFocus, containsPoint, containsPoint, contentsComponentConnected, dataContextChanged, dataContextCriteriaChanged, deparent, depeer, disable, doValueDictation, doVoiceCommand, enable, encloses, endBatchCreation, focus, focusAfterGroup, focusAtEnd, focusInNextTabElement, focusInPreviousTabElement, getAbsoluteLeft, getAbsoluteTop, getAccessKey, getAdaptiveHeightPriority, getAdaptiveWidthPriority, getAllCanvases, getAllCanvases, getAllCanvases, getAlwaysManageFocusNavigation, getAlwaysShowScrollbars, getAnimateAcceleration, getAnimateFadeTime, getAnimateHideAcceleration, getAnimateHideEffect, getAnimateHideTime, getAnimateMoveAcceleration, getAnimateMoveTime, getAnimateRectAcceleration, getAnimateRectTime, getAnimateResizeAcceleration, getAnimateResizeLayoutMode, getAnimateResizeTime, getAnimateScrollAcceleration, getAnimateScrollTime, getAnimateShowAcceleration, getAnimateShowEffect, getAnimateShowTime, getAnimateTime, getAppImgDir, getAriaHandleID, getAriaRole, getAutoMaskComponents, getAutoParent, getAutoPopulateData, getAutoRevertStyles, getAutoShowParent, getBackgroundColor, getBackgroundImage, getBackgroundPosition, getBackgroundRepeat, getBorder, getBorderRadius, getBorderRadiusAsString, getBottom, getById, getByJSObject, getByLocalId, getCanAcceptDrop, getCanAdaptHeight, getCanAdaptWidth, getCanDrag, getCanDragReposition, getCanDragResize, getCanDragScroll, getCanDrop, getCanDropBefore, getCanDropContent, getCanDropFiles, getCanFocus, getCanHover, getCanSelectText, getCanvasAutoChild, getCanvasItem, getChildren, getChildrenAsStringArray, getChildrenResizeSnapAlign, getChildrenSnapAlign, getChildrenSnapCenterAlign, getChildrenSnapEdgeAlign, getChildrenSnapResizeToGrid, getChildrenSnapToGrid, getChildTabPosition, getClassName, getComponentMask, getComponentMaskDefaults, getContentElement, getContents, getContentsComponentDefaults, getContextMenu, getControlHeight, getCorrectZoomOverflow, getCursor, getDataContext, getDataContextCriteria, getDataContextCriteria, getDataPath, getDefaultHeight, getDefaultWidth, getDeferActionConversion, getDefiningProperty, getDefiningPropertyName, getDefiningPropertyNameOptions, getDestroyed, getDestroying, getDisabled, getDisabledCursor, getDisableTouchScrollingForDrag, getDoubleClickDelay, getDragAppearance, getDragIntersectStyle, getDragMaskType, getDragMaxHeight, getDragMaxWidth, getDragMinHeight, getDragMinWidth, getDragOpacity, getDragRepositionAppearance, getDragRepositionCursor, getDragResizeAppearance, getDragScrollDelay, getDragStartDistance, getDragTarget, getDragTargetAsString, getDragType, getDropTarget, getDropTargetAsString, getDropTypes, getDropTypesAsString, getDynamicContents, getEdgeBackgroundColor, getEdgeCenterBackgroundColor, getEdgeImage, getEdgeMarginSize, getEdgeOffset, getEdgeOpacity, getEdgeShowCenter, getEdgeSize, getEditNode, getEditProxy, getElement, getElement, getEnableWhen, getEndLine, getEventEdge, getEventEdge, getEvents, getExtraSpace, getFacetId, getFloatingScrollbars, getFormItemAutoChild, getForwardSVGeventsToObject, getFullDataPath, getGroupBorderCSS, getGroupLabelBackgroundColor, getGroupLabelStyleName, getGroupPadding, getGroupTitle, getHideUsingDisplayNone, getHoverAlign, getHoverAutoDestroy, getHoverAutoFitMaxWidth, getHoverAutoFitMaxWidthAsString, getHoverAutoFitWidth, getHoverComponent, getHoverDelay, getHoverFocusKey, getHoverHeight, getHoverHTML, getHoverMoveWithMouse, getHoverOpacity, getHoverPersist, getHoverScreen, getHoverStyle, getHoverVAlign, getHoverWidth, getHoverWrap, getHSnapPosition, getHSnapPosition, getHtmlElement, getHtmlElementAsString, getHtmlPosition, getImage, getImgURL, getImgURL, getInnerContentHeight, getInnerContentWidth, getInnerHeight, getInnerWidth, getIsGroup, getIsPrinting, getIsRuleScope, getIsSnapAlignCandidate, getKeepInParentRect, getLayoutAlign, getLeaveGroupLabelSpace, getLeavePageSpace, getLeft, getLeftAsString, getLocalId, getLocateByIDOnly, getLocateChildrenBy, getLocateChildrenType, getLocatePeersBy, getLocatePeersType, getLocatorName, getMargin, getMasterCanvas, getMasterElement, getMatchElement, getMatchElementHeight, getMatchElementWidth, getMaxHeight, getMaxWidth, getMaxZoomOverflowError, getMenuConstructor, getMinHeight, getMinNonEdgeSize, getMinWidth, getMomentumScrollMinSpeed, getMouseStillDownDelay, getMouseStillDownInitialDelay, getName, getNativeAutoHideScrollbars, getNextZIndex, getNoDoubleClicks, getNoDropCursor, getOffsetHeight, getOffsetWidth, getOffsetX, getOffsetY, getOpacity, getOuterElement, getOverflow, getPadding, getPageBottom, getPageLeft, getPageRect, getPageRight, getPageTop, getPaletteDefaults, getPanelContainer, getParentCanvas, getParentCanvasAsString, getParentElement, getParentElementAsString, getPeers, getPendingMarkerStyle, getPendingMarkerVisible, getPercentBox, getPercentSource, getPersistentMatchElement, getPointerSettings, getPointerTarget, getPointerTargetAsString, getPosition, getPrefix, getPrintChildrenAbsolutelyPositioned, getPrintHTML, getPrintHTML, getPrintStyleName, getPrompt, getProportionalResizeModifiers, getProportionalResizing, getReceiveScrollbarEvents, getRect, getRedrawOnResize, getResizeBarTarget, getResizeFrom, getRight, getRuleContext, getRuleContext, getRuleScope, getScrollbarSize, getScrollBottom, getScrollHeight, getScrollLeft, getScrollRight, getScrollTop, getScrollWidth, getShadowColor, getShadowDepth, getShadowHOffset, getShadowImage, getShadowOffset, getShadowSoftness, getShadowSpread, getShadowVOffset, getShareCriteria, getShouldPrint, getShowCustomScrollbars, getShowDragShadow, getShowEdges, getShowFocusOutline, getShowHover, getShowHoverComponents, getShowPointer, getShowResizeBar, getShowShadow, getShowSnapGrid, getShrinkElementOnHide, getSingleDiv, getSizeMayChangeOnRedraw, getSnapAlignCandidates, getSnapAlignCenterLineStyle, getSnapAlignEdgeLineStyle, getSnapAxis, getSnapEdge, getSnapGridLineProperties, getSnapGridStyle, getSnapHDirection, getSnapHGap, getSnapOffsetLeft, getSnapOffsetTop, getSnapOnDrop, getSnapPosition, getSnapPosition, getSnapResizeToAlign, getSnapResizeToGrid, getSnapTo, getSnapToAlign, getSnapToCenterAlign, getSnapToEdgeAlign, getSnapToGrid, getSnapVDirection, getSnapVGap, getStartLine, getSuppressRedraw, getTabIndex, getTestDataContext, getTestInstance, getTooltip, getTop, getTopAsString, getTopElement, getTopLevelComponents, getUpdateTabPositionOnDraw, getUpdateTabPositionOnReparent, getUseBackMask, getUseCSSShadow, getUseDataContextCriteria, getUseDragMask, getUseGeneratedStyles, getUseImageForSVG, getUseNativeDrag, getUseOpacityFilter, getUseTouchScrolling, getValuesManager, getValuesManagerAsString, getViewportHeight, getViewportWidth, getVisibility, getVisibleHeight, getVisibleWhen, getVisibleWidth, getVSnapPosition, getVSnapPosition, getWorkflows, getZIndex, getZIndex, handleDataContextCriteria, handleHover, hide, hideClickMask, hideClickMask, hideComponentMask, hideComponentMask, hideContextMenu, imgHTML, imgHTML, imgHTML, initComplete, intersects, isDirty, isDisabled, isFocused, isVisible, keyUp, layoutChildren, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, markForDestroy, markForRedraw, markForRedraw, moveAbove, moveBelow, moveBy, moveTo, onAttach, onDetach, onInit, pageScrollDown, pageScrollUp, parentResized, placeNear, placeNear, placeNear, print, print, print, print, printComponents, provideRuleContext, provideRuleContext, redraw, redraw, registerAIService, registerFontScaledPaddingStyles, removeChild, removeChild, removePeer, removePeer, removeRuleContext, removeSnapAlignCandidate, resizeAutoChildAttributes, resizeBy, resizeControls, resizeControlsTo, resizeFonts, resizeFonts, resizeFonts, resizeFontsTo, resizeIcons, resizePadding, resizePadding, resizeTo, resizeTo, resolveContentsComponent, revealChild, revealChild, scrollBy, scrollByPercent, scrollTo, scrollTo, scrollTo, scrollTo, scrollTo, scrollToBottom, scrollToLeft, scrollToPercent, scrollToRight, scrollToTop, sendToBack, setAccessKey, setAdaptHeightByCustomizer, setAdaptiveHeightPriority, setAdaptiveWidthPriority, setAdaptWidthByCustomizer, setAllowExternalFilters, setAlwaysManageFocusNavigation, setAlwaysShowScrollbars, setAnimateAcceleration, setAnimateFadeTime, setAnimateHideAcceleration, setAnimateHideEffect, setAnimateHideTime, setAnimateMoveAcceleration, setAnimateMoveTime, setAnimateRectAcceleration, setAnimateRectTime, setAnimateResizeAcceleration, setAnimateResizeLayoutMode, setAnimateResizeTime, setAnimateScrollAcceleration, setAnimateScrollTime, setAnimateShowAcceleration, setAnimateShowEffect, setAnimateShowTime, setAnimateTime, setAppImgDir, setAriaRole, setAriaState, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setAutoHeight, setAutoMaskComponents, setAutoParent, setAutoPopulateData, setAutoResizeAutoChildAttributes, setAutoResizeIcons, setAutoRevertStyles, setAutoShowParent, setAutoWidth, setBackgroundColor, setBackgroundImage, setBackgroundPosition, setBackgroundRepeat, setBorder, setBorderRadius, setBorderRadius, setBottom, setCanAcceptDrop, setCanAdaptHeight, setCanAdaptWidth, setCanDrag, setCanDragReposition, setCanDragResize, setCanDragScroll, setCanDrop, setCanDropBefore, setCanDropContent, setCanDropFiles, setCanFocus, setCanHover, setCanSelectText, setChildren, setChildrenResizeSnapAlign, setChildrenSnapAlign, setChildrenSnapCenterAlign, setChildrenSnapEdgeAlign, setChildrenSnapResizeToGrid, setChildrenSnapToGrid, setComponentMaskDefaults, setContents, setContentsComponentDefaults, setContextMenu, setCorrectZoomOverflow, setCursor, setDataContext, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataPath, setDefaultHeight, setDefaultNativeAutoHideScrollbars, setDefaultPageSpace, setDefaultProperties, setDefaultShowCustomScrollbars, setDefaultWidth, setDeferActionConversion, setDefiningProperty, setDefiningPropertyNameOptions, setDisabled, setDisabledCursor, setDisableTouchScrollingForDrag, setDoubleClickDelay, setDragAppearance, setDragIntersectStyle, setDragMaskType, setDragMaxHeight, setDragMaxWidth, setDragMinHeight, setDragMinWidth, setDragOpacity, setDragRepositionAppearance, setDragRepositionCursor, setDragResizeAppearance, setDragScrollDelay, setDragStartDistance, setDragTarget, setDragTarget, setDragType, setDropTarget, setDropTarget, setDropTypes, setDropTypes, setDynamicContents, setEdgeBackgroundColor, setEdgeCenterBackgroundColor, setEdgeImage, setEdgeMarginSize, setEdgeOffset, setEdgeOpacity, setEdgeShowCenter, setEdgeSize, setEditMode, setEditMode, setEditMode, setElement, setEnableWhen, setEndLine, setExtraSpace, setFacetId, setFloatingScrollbars, setForwardSVGeventsToObject, setGroupBorderCSS, setGroupLabelBackgroundColor, setGroupLabelStyleName, setGroupPadding, setGroupTitle, setHeight, setHeight100, setHideUsingDisplayNone, setHoverAlign, setHoverAutoDestroy, setHoverAutoFitMaxWidth, setHoverAutoFitMaxWidth, setHoverAutoFitWidth, setHoverDelay, setHoverFocusKey, setHoverHeight, setHoverMoveWithMouse, setHoverOpacity, setHoverPersist, setHoverScreen, setHoverStyle, setHoverVAlign, setHoverWidth, setHoverWrap, setHtmlElement, setHtmlElement, setHtmlPosition, setImage, setImage, setInitHandler, setIsGroup, setIsRuleScope, setIsSnapAlignCandidate, setKeepInParentRect, setKeepInParentRect, setKeepInParentRect, setLayoutAlign, setLayoutAlign, setLeaveGroupLabelSpace, setLeavePageSpace, setLeft, setLeft, setLocateByIDOnly, setLocateChildrenBy, setLocateChildrenType, setLocatePeersBy, setLocatePeersType, setLocatorName, setLocatorParent, setLocatorParent, setLogicalStructure, setMargin, setMatchElement, setMatchElementHeight, setMatchElementWidth, setMaxHeight, setMaxWidth, setMaxZoomOverflowError, setMenuConstructor, setMinHeight, setMinNonEdgeSize, setMinWidth, setMomentumScrollMinSpeed, setMouseStillDownDelay, setMouseStillDownInitialDelay, setName, setNativeAutoHideScrollbars, setNeverUseFilters, setNoDoubleClicks, setNoDropCursor, setOpacity, setOverflow, setPadding, setPageLeft, setPageTop, setPanelContainer, setParentCanvas, setParentCanvas, setParentElement, setParentElement, setPeers, setPendingMarkerStyle, setPendingMarkerVisible, setPercentBox, setPercentSource, setPersistentMatchElement, setPointerSettings, setPointerTarget, setPosition, setPrefix, setPrintChildrenAbsolutelyPositioned, setPrintStyleName, setPrompt, setProportionalResizeModifiers, setProportionalResizing, setReceiveScrollbarEvents, setRect, setRect, setRedrawOnResize, setRelativeTabPosition, setResizeBarTarget, setResizeFrom, setResizeFrom, setRight, setRuleScope, setScrollbarConstructor, setScrollbarSize, setShadowColor, setShadowDepth, setShadowHOffset, setShadowImage, setShadowOffset, setShadowSoftness, setShadowSpread, setShadowVOffset, setShareCriteria, setShouldPrint, setShowCustomScrollbars, setShowDragShadow, setShowEdges, setShowFocusOutline, setShowHover, setShowHoverComponents, setShowPointer, setShowResizeBar, setShowShadow, setShowSnapGrid, setShrinkElementOnHide, setSingleDiv, setSizeMayChangeOnRedraw, setSmoothFade, setSnapAlignCandidates, setSnapAlignCenterLineStyle, setSnapAlignEdgeLineStyle, setSnapAxis, setSnapEdge, setSnapGridLineProperties, setSnapGridStyle, setSnapHDirection, setSnapHGap, setSnapOffsetLeft, setSnapOffsetTop, setSnapOnDrop, setSnapResizeToAlign, setSnapResizeToGrid, setSnapTo, setSnapToAlign, setSnapToCenterAlign, setSnapToEdgeAlign, setSnapToGrid, setSnapVDirection, setSnapVGap, setStartLine, setSuppressRedraw, setTabIndex, setTestDataContext, setTooltip, setTop, setTop, setUpdateTabPositionOnDraw, setUpdateTabPositionOnReparent, setUseBackMask, setUseCSSShadow, setUseDataContextCriteria, setUseDragMask, setUseGeneratedStyles, setUseImageForSVG, setUseNativeDrag, setUseOpacityFilter, setUseTouchScrolling, setValuesManager, setValuesManager, setVisibility, setVisible, setVisibleWhen, setWidth, setWidth100, setWorkflows, setZIndex, shouldDragScroll, show, showClickMask, showComponentMask, showComponentMask, showNextTo, showNextTo, showNextTo, showNextTo, showPendingMarker, showPrintPreview, showPrintPreview, showPrintPreview, showPrintPreview, showRecursively, startBatchCreation, startDebuggingOverflow, stopDebuggingOverflow, subtractRects, supportsValueDictation, supportsVoiceCommands, unregisterAIService, updateChildTabPosition, updateChildTabPositions, updateEditNode, updateHover, updateHover, updateShadow, updateTabPositionForDraw, visibleAtPoint, willAcceptDrop`

  ### Methods inherited from class com.smartgwt.client.widgets.BaseWidget

  `addDrawHandler, addDynamicProperty, addDynamicProperty, addDynamicProperty, addDynamicProperty, applyFactoryProperties, clearDynamicProperty, completeCreation, destroy, doAddHandler, doInit, doOnRender, draw, equals, error, errorIfNotCreated, getAttribute, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDateArray, getAttributeAsDouble, getAttributeAsElement, getAttributeAsFloat, getAttributeAsFloatArray, getAttributeAsInt, getAttributeAsIntArray, getAttributeAsJavaScriptObject, getAttributeAsMap, getAttributeAsObject, getAttributeAsRecord, getAttributeAsString, getAttributeAsStringArray, getAutoDraw, getConfig, getDOM, getHandlerCount, getID, getInnerHTML, getJsObj, getOrCreateJsObj, getRef, getScClassName, hasAutoAssignedID, hasDynamicProperty, hashCode, initNativeObject, internalSetID, internalSetID, isConfigOnly, isCreated, isDrawn, isFactoryCreated, onBind, onDestroy, onDraw, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAutoDraw, setConfig, setConfigOnly, setDefaultProperties, setDragTracker, setFactoryCreated, setID, setJavaScriptObject, setLogicalStructure, setLogicalStructure, setNullProperty, setPosition, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setScClassName, toString`

  ### Methods inherited from class com.google.gwt.user.client.ui.Widget

  `addAttachHandler, addBitlessDomHandler, addDomHandler, addHandler, asWidget, asWidgetOrNull, createHandlerManager, delegateEvent, doAttachChildren, doDetachChildren, fireEvent, getLayoutData, getParent, isAttached, isOrWasAttached, onBrowserEvent, onLoad, onUnload, removeFromParent, setLayoutData, sinkEvents, unsinkEvents`

  ### Methods inherited from class com.google.gwt.user.client.ui.UIObject

  `addStyleDependentName, ensureDebugId, ensureDebugId, ensureDebugId, getStyleElement, getStyleName, getStylePrimaryName, getStylePrimaryName, isVisible, onEnsureDebugId, removeStyleDependentName, removeStyleName, resolvePotentialElement, setElement, setPixelSize, setSize, setStyleDependentName, setStyleName, setStyleName, setStyleName, setStylePrimaryName, setStylePrimaryName, setVisible, sinkBitlessEvent`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

  `fireEvent`

- ## Constructor Details

  - ### Scrollbar

    public Scrollbar()

  - ### Scrollbar

    public Scrollbar(JavaScriptObject jsObj)

- ## Method Details

  - ### getOrCreateRef

    public static Scrollbar getOrCreateRef(JavaScriptObject jsObj)

  - ### changeAutoChildDefaults

    public static void changeAutoChildDefaults(String autoChildName, Canvas defaults)
    Changes the defaults for Canvas AutoChildren named `autoChildName`.
    Parameters:
      `autoChildName` - name of an AutoChild to customize the defaults for.
      `defaults` - Canvas defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
    See Also:
      - `AutoChildUsage`

  - ### changeAutoChildDefaults

    public static void changeAutoChildDefaults(String autoChildName, FormItem defaults)
    Changes the defaults for FormItem AutoChildren named `autoChildName`.
    Parameters:
      `autoChildName` - name of an AutoChild to customize the defaults for.
      `defaults` - FormItem defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
    See Also:
      - `AutoChildUsage`

  - ### create

    protected JavaScriptObject create()
    Overrides:
      `create` in class `StretchImg`

  - ### setAllowThumbDownState

    public Scrollbar setAllowThumbDownState(Boolean allowThumbDownState) throws IllegalStateException
    If true, the thumb's appearance changes when it's clicked on.

    Note : This is an advanced setting

    Parameters:
      `allowThumbDownState` - New allowThumbDownState value. Default value is false
    Returns:
      `Scrollbar` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getAllowThumbDownState

    public Boolean getAllowThumbDownState()
    If true, the thumb's appearance changes when it's clicked on.
    Returns:
      Current allowThumbDownState value. Default value is false

  - ### setAllowThumbOverState

    public Scrollbar setAllowThumbOverState(Boolean allowThumbOverState) throws IllegalStateException
    If true, the thumb's appearance changes when the user rolls over it.

    Note : This is an advanced setting

    Parameters:
      `allowThumbOverState` - New allowThumbOverState value. Default value is false
    Returns:
      `Scrollbar` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getAllowThumbOverState

    public Boolean getAllowThumbOverState()
    If true, the thumb's appearance changes when the user rolls over it.
    Returns:
      Current allowThumbOverState value. Default value is false

  - ### setAutoEnable

    public Scrollbar setAutoEnable(Boolean autoEnable)
    If true, this scrollbar will automatically enable when the scrollTarget is scrollable (i.e., when the contents of the scrollTarget exceed its clip size in the direction relevant to this scrollbar), and automatically disable when the scrollTarget is not scrollable. Set this property to false for full manual control over a scrollbar's enabled state.

    Note : This is an advanced setting

    Parameters:
      `autoEnable` - New autoEnable value. Default value is true
    Returns:
      `Scrollbar` instance, for chaining setter calls

  - ### getAutoEnable

    public Boolean getAutoEnable()
    If true, this scrollbar will automatically enable when the scrollTarget is scrollable (i.e., when the contents of the scrollTarget exceed its clip size in the direction relevant to this scrollbar), and automatically disable when the scrollTarget is not scrollable. Set this property to false for full manual control over a scrollbar's enabled state.
    Returns:
      Current autoEnable value. Default value is true

  - ### setBtnSize

    public Scrollbar setBtnSize(Integer btnSize)
    The size of the square buttons (arrows) at the ends of this scrollbar. This overrides `Canvas.scrollbarSize` to set the width of a vertical scrollbar or the height of a horizontal scrollbar. If not set it will default to `Canvas.scrollbarSize`.
    Parameters:
      `btnSize` - New btnSize value. Default value is null
    Returns:
      `Scrollbar` instance, for chaining setter calls

  - ### getBtnSize

    public Integer getBtnSize()
    The size of the square buttons (arrows) at the ends of this scrollbar. This overrides `Canvas.scrollbarSize` to set the width of a vertical scrollbar or the height of a horizontal scrollbar. If not set it will default to `Canvas.scrollbarSize`.
    Returns:
      Current btnSize value. Default value is null

  - ### setCornerImg

    public Scrollbar setCornerImg(StretchItem cornerImg) throws IllegalStateException
    The StretchItem for the corner between vertical and horizontal scrollbars. The width and height are determined automatically, so `StretchItem.width` and `StretchItem.height` set on the cornerImg StretchItem are ignored. The default is: `new StretchItem("corner", null, null)`
    Parameters:
      `cornerImg` - New cornerImg value. Default value is see below
    Returns:
      `Scrollbar` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getCornerImg

    public StretchItem getCornerImg()
    The StretchItem for the corner between vertical and horizontal scrollbars. The width and height are determined automatically, so `StretchItem.width` and `StretchItem.height` set on the cornerImg StretchItem are ignored. The default is: `new StretchItem("corner", null, null)`
    Returns:
      Current cornerImg value. Default value is see below

  - ### setCornerSize

    public Scrollbar setCornerSize(Integer cornerSize) throws IllegalStateException
    Allows the size of the corner segment to be set independently of the `btnSize`.
    Parameters:
      `cornerSize` - New cornerSize value. Default value is null
    Returns:
      `Scrollbar` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getCornerSize

    public Integer getCornerSize()
    Allows the size of the corner segment to be set independently of the `btnSize`.
    Returns:
      Current cornerSize value. Default value is null

  - ### setCornerSrc

    public Scrollbar setCornerSrc(String cornerSrc) throws IllegalStateException
    URL for the corner image, a singular image that appears in the corner when both h and v scrollbars are showing.
    Parameters:
      `cornerSrc` - New cornerSrc value. Default value is "[SKIN]corner.gif"
    Returns:
      `Scrollbar` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `SCImgURL`
      - `Images overview and related methods`

  - ### getCornerSrc

    public String getCornerSrc()
    URL for the corner image, a singular image that appears in the corner when both h and v scrollbars are showing.
    Returns:
      Current cornerSrc value. Default value is "[SKIN]corner.gif"
    See Also:
      - `SCImgURL`
      - `Images overview and related methods`

  - ### setEndImg

    public Scrollbar setEndImg(StretchItem endImg) throws IllegalStateException
    The StretchItem for the end of a scrollbar (the "scroll down" or "scroll right" button image). The default is: `new StretchItem("end", "btnSize", "btnSize")`
    Parameters:
      `endImg` - New endImg value. Default value is see below
    Returns:
      `Scrollbar` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getEndImg

    public StretchItem getEndImg()
    The StretchItem for the end of a scrollbar (the "scroll down" or "scroll right" button image). The default is: `new StretchItem("end", "btnSize", "btnSize")`
    Returns:
      Current endImg value. Default value is see below

  - ### setEndThumbOverlap

    public Scrollbar setEndThumbOverlap(Integer endThumbOverlap) throws IllegalStateException
    Number of pixels the thumb is allowed to overlap the buttons at the end of the track. Default prevents doubling of 1px borders. Set higher to allow media that shows curved joins between the track button and ScrollThumb.

    Note : This is an advanced setting

    Parameters:
      `endThumbOverlap` - New endThumbOverlap value. Default value is null
    Returns:
      `Scrollbar` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getEndThumbOverlap

    public Integer getEndThumbOverlap()
    Number of pixels the thumb is allowed to overlap the buttons at the end of the track. Default prevents doubling of 1px borders. Set higher to allow media that shows curved joins between the track button and ScrollThumb.
    Returns:
      Current endThumbOverlap value. Default value is null

  - ### setHSrc

    public Scrollbar setHSrc(String hSrc) throws IllegalStateException
    Base URL for the images used for the horizontal scrollbar track and end buttons.

    See `StretchImg.items` for a general explanation of how this base URL is transformed into various pieces and states.

    For a normal 3-segment track, the suffixes "_start", "_track" and "_end" are added to this URL. The "start" and "end" images should appear to be buttons (the user can click on these segments to scroll slowly). The "track" segment provides a background for the space in which the thumb can be dragged, and can also be clicked on to scroll quickly.

    For a 5-segment track (`showTrackEnds`:true), the suffixes are "_start", "_track_start", "_track", "_track_end" and "_end".

    Overrides:
      `setHSrc` in class `StretchImg`
    Parameters:
      `hSrc` - New hSrc value. Default value is "[SKIN]hscroll.gif"
    Returns:
      `Scrollbar` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `SCImgURL`
      - `Images overview and related methods`

  - ### getHSrc

    public String getHSrc()
    Base URL for the images used for the horizontal scrollbar track and end buttons.

    See `StretchImg.items` for a general explanation of how this base URL is transformed into various pieces and states.

    For a normal 3-segment track, the suffixes "_start", "_track" and "_end" are added to this URL. The "start" and "end" images should appear to be buttons (the user can click on these segments to scroll slowly). The "track" segment provides a background for the space in which the thumb can be dragged, and can also be clicked on to scroll quickly.

    For a 5-segment track (`showTrackEnds`:true), the suffixes are "_start", "_track_start", "_track", "_track_end" and "_end".

    Overrides:
      `getHSrc` in class `StretchImg`
    Returns:
      Current hSrc value. Default value is "[SKIN]hscroll.gif"
    See Also:
      - `SCImgURL`
      - `Images overview and related methods`

  - ### setScrollTarget

    public Scrollbar setScrollTarget(Canvas scrollTarget)
    The widget whose contents should be scrolled by this scrollbar. The scrollbar thumb is sized according to the amount of visible vs. scrollable content in this widget.
    If this method is called after the component has been drawn/initialized: Sets or clears the scrollbar's scrollTarget. If no argument is provided, then the scrollTarget will be set to the scrollbar itself.

    Note : This is an advanced setting

    Parameters:
      `scrollTarget` - target canvas to be scrolled. Default value is null
    Returns:
      `Scrollbar` instance, for chaining setter calls

  - ### getScrollTarget

    public Canvas getScrollTarget()
    The widget whose contents should be scrolled by this scrollbar. The scrollbar thumb is sized according to the amount of visible vs. scrollable content in this widget.
    Returns:
      Current scrollTarget value. Default value is null

  - ### setShowCorner

    public Scrollbar setShowCorner(Boolean showCorner) throws IllegalStateException
    If true, displays a corner piece at the bottom end of a vertical scrollbar, or the right end of a horizontal scrollbar. This is typically set only when both horizontal and vertical scrollbars are displayed and about the same corner.

    Note : This is an advanced setting

    Parameters:
      `showCorner` - New showCorner value. Default value is false
    Returns:
      `Scrollbar` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getShowCorner

    public Boolean getShowCorner()
    If true, displays a corner piece at the bottom end of a vertical scrollbar, or the right end of a horizontal scrollbar. This is typically set only when both horizontal and vertical scrollbars are displayed and about the same corner.
    Returns:
      Current showCorner value. Default value is false

  - ### setShowTrackButtons

    public Scrollbar setShowTrackButtons(Boolean showTrackButtons) throws IllegalStateException
    Should the track buttons that allow page scrolling be shown?

    Note : This is an advanced setting

    Parameters:
      `showTrackButtons` - New showTrackButtons value. Default value is true
    Returns:
      `Scrollbar` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getShowTrackButtons

    public Boolean getShowTrackButtons()
    Should the track buttons that allow page scrolling be shown?

    Returns:
      Current showTrackButtons value. Default value is true

  - ### setShowTrackEnds

    public Scrollbar setShowTrackEnds(Boolean showTrackEnds) throws IllegalStateException
    If true, the scrollbar uses a 5-segment rather than 3-segment image representation, where the 3 interior image segments have the same state (Down, Over, etc), independent of the two outermost image segments.

    This allows certain advanced skinning designs where the track-as-such (space in which the thumb may be dragged) has curved endcaps, and is also visually stateful (that is, changes when the mouse goes down, without affecting the appearance of the outermost segments).

    Note : This is an advanced setting

    Parameters:
      `showTrackEnds` - New showTrackEnds value. Default value is false
    Returns:
      `Scrollbar` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getShowTrackEnds

    public Boolean getShowTrackEnds()
    If true, the scrollbar uses a 5-segment rather than 3-segment image representation, where the 3 interior image segments have the same state (Down, Over, etc), independent of the two outermost image segments.

    This allows certain advanced skinning designs where the track-as-such (space in which the thumb may be dragged) has curved endcaps, and is also visually stateful (that is, changes when the mouse goes down, without affecting the appearance of the outermost segments).

    Returns:
      Current showTrackEnds value. Default value is false

  - ### setSkinImgDir

    public Scrollbar setSkinImgDir(String skinImgDir) throws IllegalStateException
    Where are the skin images for the Scrollbar. This is local to the `overall skin directory`.

    Note : This is an advanced setting

    Overrides:
      `setSkinImgDir` in class `Canvas`
    Parameters:
      `skinImgDir` - New skinImgDir value. Default value is "images/Scrollbar/"
    Returns:
      `Scrollbar` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `SCImgURL`
      - `Images overview and related methods`

  - ### getSkinImgDir

    public String getSkinImgDir()
    Where are the skin images for the Scrollbar. This is local to the `overall skin directory`.
    Overrides:
      `getSkinImgDir` in class `Canvas`
    Returns:
      Current skinImgDir value. Default value is "images/Scrollbar/"
    See Also:
      - `SCImgURL`
      - `Images overview and related methods`

  - ### setStartImg

    public Scrollbar setStartImg(StretchItem startImg) throws IllegalStateException
    The StretchItem for the start of a scrollbar (the "scroll up" or "scroll left" button image). The default is: `new StretchItem("start", "btnSize", "btnSize")`
    Parameters:
      `startImg` - New startImg value. Default value is see below
    Returns:
      `Scrollbar` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getStartImg

    public StretchItem getStartImg()
    The StretchItem for the start of a scrollbar (the "scroll up" or "scroll left" button image). The default is: `new StretchItem("start", "btnSize", "btnSize")`
    Returns:
      Current startImg value. Default value is see below

  - ### setStartThumbOverlap

    public Scrollbar setStartThumbOverlap(Integer startThumbOverlap) throws IllegalStateException
    Number of pixels the thumb is allowed to overlap the buttons at the start of the track. Default prevents doubling of 1px borders. Set higher to allow media that shows curved joins between the track button and ScrollThumb.

    Note : This is an advanced setting

    Parameters:
      `startThumbOverlap` - New startThumbOverlap value. Default value is null
    Returns:
      `Scrollbar` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getStartThumbOverlap

    public Integer getStartThumbOverlap()
    Number of pixels the thumb is allowed to overlap the buttons at the start of the track. Default prevents doubling of 1px borders. Set higher to allow media that shows curved joins between the track button and ScrollThumb.
    Returns:
      Current startThumbOverlap value. Default value is null

  - ### setThumbInset

    public Scrollbar setThumbInset(Integer thumbInset) throws IllegalStateException
    Inset of the thumb relative to the track. An inset of N pixels means the thumb is 2N pixels smaller in breadth than the track.

    Note : This is an advanced setting

    Parameters:
      `thumbInset` - New thumbInset value. Default value is null
    Returns:
      `Scrollbar` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getThumbInset

    public Integer getThumbInset()
    Inset of the thumb relative to the track. An inset of N pixels means the thumb is 2N pixels smaller in breadth than the track.
    Returns:
      Current thumbInset value. Default value is null

  - ### setThumbMinSize

    public Scrollbar setThumbMinSize(int thumbMinSize) throws IllegalStateException
    The minimum pixel size of the draggable thumb regardless of how large the scrolling region becomes.

    Note : This is an advanced setting

    Parameters:
      `thumbMinSize` - New thumbMinSize value. Default value is 12
    Returns:
      `Scrollbar` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getThumbMinSize

    public int getThumbMinSize()
    The minimum pixel size of the draggable thumb regardless of how large the scrolling region becomes.
    Returns:
      Current thumbMinSize value. Default value is 12

  - ### setThumbOverlap

    public Scrollbar setThumbOverlap(int thumbOverlap) throws IllegalStateException
    Number of pixels the thumb is allowed to overlap the buttons at each end of the track. Default prevents doubling of 1px borders. Set higher to allow media that shows curved joins between the track button and ScrollThumb.

    Note : This is an advanced setting

    Parameters:
      `thumbOverlap` - New thumbOverlap value. Default value is 1
    Returns:
      `Scrollbar` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getThumbOverlap

    public int getThumbOverlap()
    Number of pixels the thumb is allowed to overlap the buttons at each end of the track. Default prevents doubling of 1px borders. Set higher to allow media that shows curved joins between the track button and ScrollThumb.
    Returns:
      Current thumbOverlap value. Default value is 1

  - ### setTrackEndHeight

    public Scrollbar setTrackEndHeight(int trackEndHeight) throws IllegalStateException
    The minimum pixel height of the track end segments (if enabled with showTrackEnds).

    Note : This is an advanced setting

    Parameters:
      `trackEndHeight` - New trackEndHeight value. Default value is 12
    Returns:
      `Scrollbar` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getTrackEndHeight

    public int getTrackEndHeight()
    The minimum pixel height of the track end segments (if enabled with showTrackEnds).
    Returns:
      Current trackEndHeight value. Default value is 12

  - ### setTrackEndImg

    public Scrollbar setTrackEndImg(StretchItem trackEndImg) throws IllegalStateException
    The StretchItem for the end of a scrollbar track. The default is: `new StretchItem("track_end", "trackEndSize", "trackEndSize")`
    Parameters:
      `trackEndImg` - New trackEndImg value. Default value is see below
    Returns:
      `Scrollbar` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getTrackEndImg

    public StretchItem getTrackEndImg()
    The StretchItem for the end of a scrollbar track. The default is: `new StretchItem("track_end", "trackEndSize", "trackEndSize")`
    Returns:
      Current trackEndImg value. Default value is see below

  - ### setTrackEndWidth

    public Scrollbar setTrackEndWidth(int trackEndWidth) throws IllegalStateException
    The minimum pixel width of the track end segments (if enabled with showTrackEnds).

    Note : This is an advanced setting

    Parameters:
      `trackEndWidth` - New trackEndWidth value. Default value is 12
    Returns:
      `Scrollbar` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getTrackEndWidth

    public int getTrackEndWidth()
    The minimum pixel width of the track end segments (if enabled with showTrackEnds).
    Returns:
      Current trackEndWidth value. Default value is 12

  - ### setTrackImg

    public Scrollbar setTrackImg(StretchItem trackImg) throws IllegalStateException
    The StretchItem for the middle part of a scrollbar track, which usually takes up the majority of the width or height of the scrollbar. The default is: `new StretchItem("track", "*", "*")`
    Parameters:
      `trackImg` - New trackImg value. Default value is see below
    Returns:
      `Scrollbar` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getTrackImg

    public StretchItem getTrackImg()
    The StretchItem for the middle part of a scrollbar track, which usually takes up the majority of the width or height of the scrollbar. The default is: `new StretchItem("track", "*", "*")`
    Returns:
      Current trackImg value. Default value is see below

  - ### setTrackStartImg

    public Scrollbar setTrackStartImg(StretchItem trackStartImg) throws IllegalStateException
    The StretchItem for the start of a scrollbar track. The default is: `new StretchItem("track_start", "trackStartSize", "trackStartSize")`
    Parameters:
      `trackStartImg` - New trackStartImg value. Default value is see below
    Returns:
      `Scrollbar` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getTrackStartImg

    public StretchItem getTrackStartImg()
    The StretchItem for the start of a scrollbar track. The default is: `new StretchItem("track_start", "trackStartSize", "trackStartSize")`
    Returns:
      Current trackStartImg value. Default value is see below

  - ### setVSrc

    public Scrollbar setVSrc(String vSrc) throws IllegalStateException
    Base URL for the images used for the vertical scrollbar track and end buttons. See `hSrc` for usage.
    Overrides:
      `setVSrc` in class `StretchImg`
    Parameters:
      `vSrc` - New vSrc value. Default value is "[SKIN]vscroll.gif"
    Returns:
      `Scrollbar` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `SCImgURL`
      - `Images overview and related methods`

  - ### getVSrc

    public String getVSrc()
    Base URL for the images used for the vertical scrollbar track and end buttons. See `hSrc` for usage.
    Overrides:
      `getVSrc` in class `StretchImg`
    Returns:
      Current vSrc value. Default value is "[SKIN]vscroll.gif"
    See Also:
      - `SCImgURL`
      - `Images overview and related methods`

  - ### setDefaultProperties

    public static void setDefaultProperties(Scrollbar scrollbarProperties)
    Class level method to set the default properties of this class. If set, then all existing and subsequently created instances of this class will automatically have default properties corresponding to the properties set on the SmartGWT class instance passed to this function before its underlying SmartClient JS object was created. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

    Note: This method is intended for setting default attributes only and will affect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead. Calling this method after instances have been created can result in undefined behavior, since it bypasses any setters and a class instance may have already examined a particular property and not be expecting any changes through this route.

    Parameters:
      `scrollbarProperties` - properties that should be used as new defaults when instances of this class are created
    See Also:
      - `SGWTProperties`

  - ### preloadImages

    public static void preloadImages()
    Preload primary Scrollbar skin images.

  - ### setLogicalStructure

    public LogicalStructureObject setLogicalStructure(ScrollbarLogicalStructure s)
    Setter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.

  - ### getLogicalStructure

    public LogicalStructureObject getLogicalStructure()
    Getter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
    Specified by:
      `getLogicalStructure` in interface `LogicalStructure`
    Overrides:
      `getLogicalStructure` in class `StretchImg`